{
Copyright () 2005,  by Germn Estvez (Neftal)
http://neftali.clubdelphi.com/

  Muestra como calcular el espacio ocupado, total y libre de discos;
  Y el espacio que ocupa un directorio.

=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras, ampliaciones,
  errores y/o cualquier otro tipo de sugerencia envame un mail a:
  german_ral@hotmail.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
errors and/or any another type of suggestion send a mail to:
german_ral@hotmail.com
=========================================================================

@author Germn Estvez (Neftal)
@cat Samples
}
unit FMain;

//=========================================================================
//
// I N I T I A L I Z A T I O N
//
//=========================================================================
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ShellAPI;

type
  TFormMain = class(TForm)
    Panel1: TPanel;
    edtbytes: TEdit;
    edtKB: TEdit;
    edtMB: TEdit;
    edtGB: TEdit;
    StatusBar2: TStatusBar;
    Panel2: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    btnFreeSpace: TButton;
    mmDiscos: TMemo;
    mmTotal: TMemo;
    mmFree: TMemo;
    Panel3: TPanel;
    Label5: TLabel;
    edtDirName: TEdit;
    btnDirSize: TButton;
    Panel4: TPanel;
    Label1: TLabel;
    edtFileSize1: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure btnFreeSpaceClick(Sender: TObject);
    procedure btnDirSizeClick(Sender: TObject);
    procedure StatusBar2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function GetFileSize(FileName: string): Int64;
    procedure GetFreeSpace(APath:String; var AFreeAvailable:Int64;
                                        var ATotalSpace:Int64);
    function CalcFolderSize(aRootPath: string): Int64;
    procedure ConvertFileSizes(Size:Int64; sizeKB:Double=0; sizeMB:Double=0);

  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation

{$R *.dfm}




function TFormMain.GetFileSize(FileName: string): Int64;
var
  Srec: TSearchRec;
  Size: Real;
begin
  // Buscar el fichero
  if FindFirst(FileName, faAnyFile, Srec) = 0 then
    // Obtener tamao (concatenamos para los grandes)
    Result := Srec.FindData.nFileSizeHigh * MAXDWORD +
              Srec.FindData.nFileSizeLow
  else
    // no encontrado
    Result := 0;

  // cerrar
  FindClose(Srec);
end;


procedure TFormMain.Button1Click(Sender: TObject);
var
  Size:Int64;
begin

  // Existe?
  if FileExists(edtFileSize1.Text) then begin
    Size := Self.GetFileSize(edtFileSize1.Text);
  end;

  // Convertir tamaos
  ConvertFileSizes(Size);

end;

procedure TFormMain.ConvertFileSizes(Size:Int64; sizeKB:Double=0; sizeMB:Double=0);
begin

  // Bytes
  edtbytes.Text := IntToStr(Size) + '  b';

  // KB
  sizeKB := (Size / 1024);
  edtKB.Text := FloatToStrF(SizeKB, ffFixed, 18 ,2) + ' KB';

  // MB
  SizeMB := (Size / 1048576);
  edtMB.Text := FloatToStrF(SizeMB, ffFixed, 18 ,2) + ' MB';

  // GB
  edtGB.Text := FloatToStrF((Size / 1073741824), ffFixed, 18 ,2) + ' GB';

end;

procedure TFormMain.GetFreeSpace(APath:String; var AFreeAvailable:Int64;
                                              var ATotalSpace:Int64);
begin
  // Usando la API
  GetDiskFreeSpaceEx(PChar(APath), AFreeAvailable, ATotalSpace, Nil);
end;



procedure TFormMain.btnFreeSpaceClick(Sender: TObject);
var
  Drive:char;
  i:Integer;
  TotalBytes: Int64;
  TotalFree: Int64;
begin

  // Limpiar los memos
  mmTotal.Clear;
  mmFree.Clear;

  // Para cada unidad
  for i := 0 to (mmDiscos.Lines.Count - 1) do begin
    // La linea no es vaca
    if (mmDiscos.Lines[i] <> '') then begin
      Drive := mmDiscos.Lines[i][1];
      // Existe?
      if DirectoryExists(Drive + ':\') then begin
        // espacio libre
        GetFreeSpace(Drive + ':\', TotalBytes, TotalFree);
        // Aadir a los memos
        mmTotal.Lines.Add(
          FloatToStrF((TotalBytes / 1073741824), ffFixed, 18 ,2) + ' GB');
        mmFree.Lines.Add(
          FloatToStrF((TotalFree / 1073741824), ffFixed, 18 ,2) + ' GB');
      end;
    end;
  end;

end;


function TFormMain.CalcFolderSize(aRootPath: string): Int64;

  // calcular tamao (recursivo)
  procedure CalcSize(const aFolder: string);
  var
    Data: TWin32FindData;
    FileHandle: THandle;
  begin
    // Acceder al fichero
    FileHandle := FindFirstFile(PCHAR(aFolder + '*'), Data);
    // Es correcto?
    if (FileHandle <> INVALID_HANDLE_VALUE) then begin

      // Proteccon
      try
        repeat
          // Contiene otros directorios?
          if (Data.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY > 0) and
             (Data.cFileName[0] <> '.') then begin
            // Tamao de forma recursiva
            CalcSize(aFolder + Data.cFilename + '\')
          end
          else begin
            // Vamos sumando
            Inc(Result, (Data.nFileSizeHigh * MAXDWORD) + Data.nFileSizeLow);
          end;
        // acaba cuando ya no encuntra ms directorios
        until not FindNextFile(FileHandle, Data);
      // cerrar
      finally
        Windows.FindClose(FileHandle);
      end;
    end;
  end;

begin
  Result := 0;
  // Aadir la barra
  if aRootPath[Length(aRootPath)] <> '\' then
    aRootPath := aRootPath + '\';
  // Calcular
  CalcSize(aRootPath);
end;


procedure TFormMain.btnDirSizeClick(Sender: TObject);
var
  Size:Int64;
begin

  // Existe?
  if FileExists(edtFileSize1.Text) then begin
    Size := Self.CalcFolderSize(edtDirName.Text);
  end;

  ConvertFileSizes(Size);

end;

procedure TFormMain.StatusBar2Click(Sender: TObject);
begin
  // Pgina web
  ShellExecute(Handle, 'open', 'http://neftali.clubdelphi.com/', 0, 0, 0);
end;

procedure TFormMain.Button2Click(Sender: TObject);
var
  Drive:char;
  i:Integer;
  TotalBytes: Int64;
  TotalFree: Int64;
begin

  mmTotal.Clear;
  mmFree.Clear;

  for i := 0 to (mmDiscos.Lines.Count - 1) do begin
    if (mmDiscos.Lines[i] <> '') then begin
      Drive := mmDiscos.Lines[i][1];

      // Existe?
      if DirectoryExists(Drive + ':\') then begin

        TotalBytes := DiskFree(Ord(Drive) - 64);
        TotalFree := DiskSize(Ord(Drive) - 64);

        mmTotal.Lines.Add(
          FloatToStrF((TotalBytes / 1073741824), ffFixed, 18 ,2) + ' GB');
        mmFree.Lines.Add(
          FloatToStrF((TotalFree / 1073741824), ffFixed, 18 ,2) + ' GB');
      end;
    end;
  end;

end;

end.

